{ This is the input data:
D4 A3 A8 H1 H8
                                 
                                 -------
                   
                    1998 .

          8 x 8.      
    .       
  ,         -  
     "",  -    .   
  "" .           ,  -
                  
 .             -
              .  -
        .     : -
   ,    ,     ..   
         (  ). 
       .    ,  
         .

     :           -
    ,          -
      .     -
           :  D[x,y,dx,dy]
        (x,y)   (dx,dy)  W[x,y,dx,dy]
        (x,y)   (dx,dy)  , -
        (DestX,DestY).    
 K,           (Xk,Yk),     
   .       ,   -
    K-,      (DestX,DestY)  +   ,
       (Xk,Yk) +  ,    -
    (Xk,Yk) +  ,        
 ,   D[Xk,Yk,DestX,DestY].  Xk, Yk  K    
 .           
               
               -
     .         -
            ,    -
                   -
    .  ,          
             (   
 ,        ,    ).  P[1..N] 
     P[0]    .     -
  :
     Min:=
     for DestX = 1 to 8
       for DestY = 1 to 8
         for K = 1 to N
           for Xk = 1 to 8
             for Yk = 1 to 8
               S:= Sum - D[ P[K], DestX,DestY ]
                       + D[ P[K], Xk,Yk ]
                       + D[ Xk,Yk, DestX,DestY ]
		       + W[ P[0], Xk,Yk )
	       if S < Min then Min:= S
      (Min)
   Sum   D[ P[i], DestX,DestY ]  i=1..N. 
   -  -         -
              
     .       -
     .      ,  
   .         -
    -  D[...]       . 
               
     D.


}
CONST InFileName = 'CAMELOT.PAS';
      OutFileName = '';
      MaxKnights = 128;
      MaxN = 8; {     }

TYPE Pozition = record x,y:byte; end;

VAR P: array[0..MaxKnights] of Pozition; {    }
    D: array[1..MaxN,1..MaxN,1..MaxN,1..MaxN] of byte; { }
    Count: integer; { }


Procedure ReadData; {    - P[0], Count, P[1..Count] }
Var F: Text;
    ch1,ch2,ch: char;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  Count:=-1;
  repeat
    Read(F,ch1,ch2,ch);
    Inc(Count);
    P[Count].x:= ord(ch1)-ord('A')+1;
    P[Count].y:= ord(ch2)-ord('1')+1;
  until ch <> ' ';
  Close(F);
End;

Procedure FindKnightsDistances;
{        -  D[] }
Var Visited: array[1..MaxN,1..MaxN] of boolean;
  Procedure BFS(BegX,BegY:integer); {      (BegX,BegY) }
  Var ss: array[1..MaxN*MaxN] of record x,y,dist:integer; end;
      sp,poz: integer;
    Procedure add(x,y,dist:integer);
    Begin {     (x,y)        }
      if (x<1) or (x>MaxN) or (y<1) or (y>MaxN) or Visited[x,y] then Exit;
      Visited[x,y]:=true;
      inc(sp); ss[sp].x:=x; ss[sp].y:=y; ss[sp].dist:=dist;
      D[BegX,BegY,x,y]:=dist;
    End;
  Var x,y,dist: integer;
  Begin
    sp:=0; add(BegX,BegY,0); poz:=1;
    repeat
      x:=ss[poz].x; y:=ss[poz].y; dist:=ss[poz].dist + 1;
      add(x+1,y+2,dist);
      add(x+1,y-2,dist);
      add(x+2,y+1,dist);
      add(x+2,y-1,dist);
      add(x-1,y+2,dist);
      add(x-1,y-2,dist);
      add(x-2,y+1,dist);
      add(x-2,y-1,dist);
      inc(poz);
    until poz > sp;
  End;
Var x,y: integer;
Begin
  for x:= 1 to MaxN do
    for y:= 1 to MaxN do
      begin
        FillChar(Visited,SizeOf(Visited),false);
        BFS(x,y);
      end;
End;

Procedure Print(Result:integer); {  Result    }
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  Writeln(OutF,Result);
  Close(OutF);
End;

Function Minimal: integer;
{             }
Var i, DestX, DestY, Sum, BestSum: integer;
  Procedure CalculateMinimalToDest;
  {  .         (DestX,DestY) }
     Function WalkDist(x1,y1,x2,y2:integer): integer;
        Function Max(a,b:integer): integer;
        Begin if a>b then Max:=a else Max:=b; End;
     Begin WalkDist:=max(abs(x2-x1),abs(y2-y1)); End;
  Var Knight, MountX, MountY, TotalSum: integer;
  Begin
    for Knight:= 1 to Count do
      for MountX:= 1 to MaxN do
        for MountY:= 1 to MaxN do
          begin
            TotalSum:= Sum - D[ P[Knight].x,P[Knight].y, DestX,DestY ]
                     + D[ P[Knight].x,P[Knight].y, MountX,MountY ]
                     + D[ MountX,MountY, DestX,DestY ]
		     + WalkDist( P[0].x,P[0].y, MountX,MountY );
            if TotalSum < BestSum then
	      BestSum:=TotalSum;
          end;
  End;
Begin
  BestSum:=MaxInt;
  for DestX:= 1 to MaxN do
    for DestY:= 1 to MaxN do
      begin
        Sum:=0;
        for i:= 1 to Count do
          Sum:= Sum + D[P[i].x,P[i].y, DestX,DestY];
        if Sum < BestSum then CalculateMinimalToDest;
      end;
  Minimal:=BestSum;
End;

BEGIN
  ReadData;
  FindKnightsDistances;
  Print(Minimal);
END.